/*
	PROforma, PROGS Font & Raster Manager

	PFPageClear
		routine to clear the page (only the part inside the current PageBbox)
		this can modify the current drawing colour

	   (c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 20 July 1993
	25.09.1995 modified to use new driver structure
			   the drawing colour is no longer preserved
*/

#include "gstate.h"

Error PFPageClear(Gstate gstate)
{
	Error err;
	PBbox *c=&gstate->raster->clip;
	ColourCMYK cmyk=gstate->DrawColour;
	char colourspace=gstate->drawcolourspace;

	switch (gstate->papercolourspace)
	{
		case PF_COLOURSPACE_GRAYSHADE:
			PFColourGray(gstate,gstate->PaperColour.black);
			break;
		case PF_COLOURSPACE_RGB:
			PFColourRGB(gstate,(ColourRGB *)&gstate->PaperColour);
			break;
		case PF_COLOURSPACE_CMYK:
			PFColourCMYK(gstate,&gstate->PaperColour);
			break;
		default:
			PFColourGray(gstate,0);
			break;
	}

	err=gstate->raster->bitdraw->Block(gstate->raster, c->xsiz, c->ysiz, 0, 0);

	switch (colourspace)
	{
		case PF_COLOURSPACE_GRAYSHADE:
			PFColourGray(gstate,cmyk.black);
			break;
		case PF_COLOURSPACE_RGB:
			PFColourRGB(gstate,(ColourRGB *)&cmyk);
			break;
		case PF_COLOURSPACE_CMYK:
			PFColourCMYK(gstate,&cmyk);
			break;
		default:
			PFColourGray(gstate,pt_hundred);
			break;
	}
	return err;
}
