/* PROforma, PROgs FOnt & Raster MAnager

	special driver for extracting data from PROforma

   (c) PROGS, Professional & Graphical Software
   written by Joachim Van der Auwera
   started 27 September 1995
   */

#include "gstate.h"

static Error nimp()    { return ERR_NIMP; }
static Error nothing() { return ERR_OK; }

extern DRIVdriver *screen;			/* current screen driver */

static buffsiz(Gstate gstate, int x, int y, Size *ret)
{
	*ret=0; 						/* has to be == 0 to prevent allocating */
	return ERR_OK;
}
static bbuffsiz(short x, short y, Size *ret)
{
	*ret=1; 						/* has to be != 0 to allow alloc to work */
	return ERR_OK;
}
Error InitInit(Gstate gstate, char *device, PBbox *area)
{
	return screen->Handle(1,gstate);
}

DRIVdriver dummydriver = {
	NULL, PF_PRINTERDRIVER,
	"dummy driver", 				/* name */
	1,1,							/* xdpi, ydpi */
	{ 'D','U','M','Y' },            /* type of bitmap needed */

	(Error (*)())nothing,							/* InitDriver */
	(Error (*)(char*,char*))nimp,					/* Define */

	/* routines to complete - finalise gstate */
	(Error (*)(Gstate,char*,PBbox *))InitInit,		/* InitInit */
	(Error (*)(Gstate,int,int,Size *))buffsiz,		/* BufferSize */
	(Error (*)(Gstate))nothing, 					/* InitDone */
	(Error (*)(Gstate))nothing, 					/* CleanUp */

	/* routines to display the page */
	(Error (*)(Gstate))nimp,						/* InitPage */
	(Error (*)(Gstate))nimp,						/* ShowPage */
	(Error (*)(Gstate))nimp,						/* StopPage */

	/* routines to control the displaying of pages */
	(Error (*)(Gstate,int))nimp,					/* SetCopies */
	(Error (*)(Gstate,int))nimp,					/* SetDisplayMode */
	(Error (*)(Gstate,int,int))nimp,				/* WindowMove */
	(Error (*)(Gstate))nimp,						/* BufferUpdate */
	(Error (*)(Gstate))nimp,						/* BufferSave */
	(Error (*)(Gstate))nimp,						/* BufferRestore */

	PF_COLOURSPACE_GRAYSHADE,
	{
		(Error (*)(Gstate,pt*))nimp,
		(Error (*)(Gstate,pt*,int*))nimp,
		(Error (*)(Gstate,pt*,pt*))nimp
	},

	(Error (*)(Gstate,Bbox *))nimp, 				/* GetFullPageBbox */
	(Error (*)(Gstate,char *))nimp					/* DefaultDevice */
};

BITMdriver dummybits={
	NULL, PF_BITMAPDRIVER,
	{ 'D','U','M','Y' },            /* type of bitmap */

	/* drawing routines */
	{
		(Error (*)(Bitmap,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,Mask*,short,short)) nimp,
		(Error (*)(Bitmap,short,short))nimp
	},
	{
		(Error (*)(Bitmap,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,Mask*,short,short)) nimp,
		(Error (*)(Bitmap,short,short))nimp
	},
	{
		(Error (*)(Bitmap,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,Mask*,short,short)) nimp,
		(Error (*)(Bitmap,short,short))nimp
	},
	{
		(Error (*)(Bitmap,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,short,short))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,short,short,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,pt,pt,pt,pt))nimp,
		(Error (*)(Bitmap,Mask*,short,short)) nimp,
		(Error (*)(Bitmap,short,short))nimp
	},

	nimp,		/* CursorSet */
	nimp,		/* CursorMove */
	nimp,		/* CursorGet */

	nimp,		/* PixelRead */
	nimp,		/* PixelReadNextX */
	nimp,		/* PixelReadPrevX */
	nimp,		/* PixelReadNextY */
	nimp,		/* PixelReadPrevY */
	nimp,		/* PixelSet */
	nimp,		/* PixelSetNextX */
	nimp,		/* PixelSetPrevX */
	nimp,		/* PixelSetNextY */
	nimp,		/* PixelSetPrevY */

	nimp,		/* CopyArea */

	bbuffsiz,	/* BufferSize */
	8,8,0		/* size of FastPattern && preferred direction */
	};
