	section	text
	xdef	_SPRGetColour

;  this returns the colour for a pixel in a sprite
;			0 for black
;			1 for red
;			2 for green
;			3 for white
;			4 for transparent

; on entry, the following values are on the stack:

*  4(A7)	 =	 xpix
*  8(A7)	 =	 ypix = line of the sprite
* 12(A7)	 =	 pointer to sprite


myregs	REG	A0-A2/D1-D5
offset	EQU	32

_SPRGetColour  MOVEM.L   myregs,-(A7)
	MOVE.L	12+offset(A7),A0	; point to start of sprite
	MOVE.W	4(A0),D1		; x size of sprite
	ADD.W	#$F,D1		; get width...
	AND.W	#$FFF0,D1 	; ...to nearest 16 pixels...
	LSR.W	#3,D1

none	MOVEQ	#0,D0
	MOVE.L	8+offset(A7),D2	; ypix
	MULU	D1,D2		; start of the words for this line
	LSL.W	#1,D2		; these are words!
	LEA	12(A0),A1
	MOVE.L	(A1),D0
	ADD.L	D0,A1		; point to the start of the colour info
	ADD.W	D2,A1		; start word for this line
	LEA	16(A0),A2 	; point to mask
	MOVE.L	(A2),D0
	ADD.L	D0,A2		; point to the start of the colour mask
	ADD.W	D2,A2		; start word for this line

	MOVE.L	4+offset(A7),D3	; xpix
	DIVU	#8,D3		; which word do we need?
	MOVE.W	D3,D4		; integer result
	LSL.W	#1,D4
	ADD.W	D4,A1		; point to the word now
	ADD.W	D4,A2
	SWAP	D3		; number of pixel
	MOVEQ	#7,D4
	SUB.B	D3,D4		; bit in byte
	MOVE.B	(A2),D5		; point to mask
	BTST	D4,D5		; is pixel visible?
	BEQ.S	transp		; no->...
	MOVEQ	#0,D0		; this will hold the result
	MOVE.B	(A1),D5
	BTST	D4,D5		; test this bit (green)
	BEQ.S	nogreen
	MOVEQ	#2,D0
nogreen	MOVE.B	1(A1),D5
	BTST	D4,D5
	BEQ.S	nored
	ADDQ.W	#1,D0
nored	MOVEM.L	(A7)+,myregs
	RTS
transp	MOVEQ	#4,D0
	MOVEM.L	(A7)+,myregs
	RTS

	xdef	_SprRec
; recognize routine
_sprrec	MOVE.L	4(A7),D0		; get pointer to sprite
	MOVEM.L	myregs,-(A7)
	MOVE.L	D0,A1
	MOVE.L	D0,A0		; point to string
find_end	MOVE.B	(A0)+,D0		; char of string into D0
	BEQ.S	endstr		; was it end of string? yes->...
	LSL.L	#8,D0		;
	BRA.S	find_end
endstr	ANDI.L	#$DFDFDF00,D0	; make case independent
	CMP.L	#$53501400,D0	; is it SP4?
	BNE.S	not_found 	; no->...
	LEA	$3C(A1),A1
	CMP.L	#$1000000,(A1)+	;
	BNE.S	not_found
	MOVEQ	#0,D0
	MOVEQ	#0,D2
	MOVE.W	(A1)+,D0		; x size
	BEQ.S	not_found
	MOVE.W	(A1)+,D2		; y size
	BEQ.S	not_found
	ADDQ.L	#8,A1		; point to mask...
	MOVE.L	(A1)+,D1
	ADD.L	D1,A1		; .... now
	ADD.W	#$F,D0		; get width...
	AND.W	#$FFF0,D0 	; ...to nearest 16 pixels...
	LSR.W	#3,D0
	MULU	D0,D2
	SUBQ.W	#1,D2
loop	TST.W	(A1)+
	BNE.S	found
	DBF	D2,loop
not_found MOVEQ	#-12,D0
	MOVEM.L	(A7)+,myregs
	RTS
found	MOVEQ	#0,D0
	MOVEM.L	(A7)+,myregs
	RTS



	end
         RTS

	xdef	_trap14
_trap14	trap	#14
	RTS

